package com.autocareai.mvvmdemo.demo.list

import android.os.Bundle
import androidx.lifecycle.Observer
import androidx.recyclerview.widget.LinearLayoutManager
import com.autocareai.lib.route.Route
import com.autocareai.mvvmdemo.R
import com.autocareai.mvvmdemo.common.view.BaseLifecycleActivity
import com.autocareai.mvvmdemo.demo.route.DemoRoute
import kotlinx.android.synthetic.main.activity_popular_websites.*

/**
 * <pre>
 *     author : louis wang
 *     time   : 2020/06/28
 *     desc   : 常用网站界面
 *     version: 1.0
 * </pre>
 */
@Route(path = DemoRoute.POPULAR_WEBSITES)
class PopularWebsitesActivity : BaseLifecycleActivity<PopularWebsitesViewModel>() {

    //常用网站适配器
    private val mPopularWebsitesAdapter by lazy { PopularWebsitesAdapter() }

    override fun getLayoutId(): Int = R.layout.activity_popular_websites

    override fun getViewModelClass(): Class<PopularWebsitesViewModel> =
        PopularWebsitesViewModel::class.java

    override fun initView(savedInstanceState: Bundle?) {
        recycleView.layoutManager = LinearLayoutManager(this)
        recycleView.adapter = mPopularWebsitesAdapter
    }

    override fun initListener() {
        swipeRefresh.setOnRefreshListener { loadDataOnCreate() }
    }

    override fun initLifecycleObserver() {
        mViewModel.listDataEvent.observe(this, Observer {
            swipeRefresh.isRefreshing = false
            mPopularWebsitesAdapter.setNewData(it)
        })
    }

    override fun loadDataOnCreate() {
        mViewModel.getPopularWebsites(this)
    }

}