package com.autocareai.mvvmdemo.demo.list

import androidx.lifecycle.LifecycleOwner
import com.autocareai.lib.lifecycle.extension.post
import com.autocareai.lib.lifecycle.livedata.SingleLiveEvent
import com.autocareai.mvvmdemo.common.view.BaseViewModel
import com.autocareai.mvvmdemo.demo.api.DemoApi
import com.autocareai.mvvmdemo.demo.enity.PopularWebsitesEntity

/**
 * <pre>
 *     author : louis wang
 *     time   : 2020/06/28
 *     desc   : 常用网站ViewModel
 *     version: 1.0
 * </pre>
 */
class PopularWebsitesViewModel : BaseViewModel() {

    /**
     * 常用网站数据
     */
    var listDataEvent = SingleLiveEvent<ArrayList<PopularWebsitesEntity>>()

    /**
     * 获取常用网站
     */
    fun getPopularWebsites(owner: LifecycleOwner) {
        DemoApi.getPopularWebsites()
            .attachLifecycle(owner)
            .onSuccess {
                listDataEvent.post(it)
            }.onError { _, message ->
                shortToast(message)
            }.async()
    }
}