package com.autocareai.mvvmdemo.demo.main

import androidx.lifecycle.Observer
import com.autocareai.lib.extension.onClick
import com.autocareai.lib.route.Route
import com.autocareai.mvvmdemo.R
import com.autocareai.mvvmdemo.common.view.BaseLifecycleActivity
import com.autocareai.mvvmdemo.demo.route.DemoRoute
import kotlinx.android.synthetic.main.activity_main.*

/**
 * <pre>
 *     author : Taylor Zhang
 *     time   : 2020/06/24
 *     desc   : 主界面
 *     version: 1.0.0
 * </pre>
 */
@Route(path = DemoRoute.LOGIN)
class MainActivity : BaseLifecycleActivity<MainViewModel>() {

    override fun getLayoutId(): Int = R.layout.activity_main

    override fun getViewModelClass(): Class<MainViewModel> = MainViewModel::class.java

    override fun initListener() {
        super.initListener()

        // TODO: 2020/6/24 如果防止用户短时间多次点击，使用onClick，如果用户可以多次点击，还是使用原生的setOnClickListener
        btnLogin.onClick {
            // 登录
            mViewModel.login(this, edPhone.text.toString(), edPwd.text.toString())
        }
    }

    override fun initLifecycleObserver() {
        super.initLifecycleObserver()

        mViewModel.toListEvent.observe(this, Observer {
            // 跳转至列表界面
            DemoRoute.toPopularWebsites().navigation(this)
        })
    }
}
